+(function () {
    "use strict";
    function getIdFromMail (param) {
        var full_str = param;
        var indexOfAt = full_str.indexOf('@');
        return full_str.substring(0,indexOfAt);
    }
    var WorkerStatusTable = function (selector) {
        $.fn.Table.call(this, selector);
        this.columns = [
            {
                name: "uniqueAssigneeVO.name",
                title: "작업자 이름",
                data: "uniqueAssigneeVO.name",
                className: "dt-body-center",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        return '<label style="color: #a4c6ff">' + data + "</label>";
                    }
                    return data;
                },
            },
            {
                name: "uniqueAssigneeVO.emailAddress",
                title: "작업자 메일",
                data: "uniqueAssigneeVO.emailAddress",
                className: "dt-body-center",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        if (data && data !== "") {
                            return '<label style="color: #a4c6ff">' + data + "</label>";
                        } else {
                            return '<label style="color: #a4c6ff">' +'메일 정보 없음'+'</label>';
                        }
                    }
                    return data;
                },
            },
            {
                name: "totalIssueCount",
                title: "요구사항 및 하위/연결이슈 합계",
                data: "totalIssueCount",
                className: "dt-body-right",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        if (data) {
                            return '<label style="color: #a4c6ff">' + data + "</label>";
                        } else {
                            return '<label style="color: #a4c6ff">' + '합계 정보 없음' + "</label>";
                        }

                    }
                    return data;
                },
            },
            {
                name: "reqIssueCount",
                title: "요구사항 이슈",
                data: "reqIssueCount",
                className: "dt-body-right",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        if (data) {
                            return '<label style="color: #a4c6ff">' + data + "</label>";
                        } else {
                            return '<label style="color: #a4c6ff">' + '개수 정보 없음' + "</label>";
                        }

                    }
                    return data;
                },
            },
            {
                name: "notReqIssueCount",
                title: "하위/연결이슈",
                data: "notReqIssueCount",
                className: "dt-body-right",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        if (data) {
                            return '<label style="color: #a4c6ff">' + data + "</label>";
                        } else {
                            return '<label style="color: #a4c6ff">' + 0 + "</label>";
                        }

                    }
                    return data;
                },
            },
            {
                name: "reqIssueProperties",
                title: "요구사항 이슈 상태",
                data: "reqIssueProperties",
                className: "dt-body-right",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        var reqIssueProperties = data;
                        if (reqIssueProperties && reqIssueProperties.length !== 0) {
                            let return_status = "";
                            reqIssueProperties.forEach((data, index) => {
                                return_status += data["name"] + " - " + data["value"];
                                return_status += '<br>';
                            })
                            return '<label style="color: #a4c6ff">' + return_status + "</label>";
                        } else {
                            return '<label style="color: #a4c6ff">' + ' - ' + "</label>";
                        }

                    }
                    return data;
                },
            },
            {
                name: "notReqIssueProperties",
                title: "연결이슈 상태",
                data: "notReqIssueProperties",
                className: "dt-body-right",
                defaultContent: "-",
                visible: true,
                render: function (data, type, row, meta) {
                    if (type === "display") {
                        var notReqIssueProperties = data;
                        if (notReqIssueProperties && notReqIssueProperties.length !== 0) {
                            let return_status = "";
                            notReqIssueProperties.forEach((data, index) => {
                                return_status += data["name"] + " - " + data["value"];
                                return_status += '<br>';
                            })
                            return '<label style="color: #a4c6ff">' + return_status + "</label>";
                        } else {
                            return '<label style="color: #a4c6ff">' + ' - ' + "</label>";
                        }

                    }
                    return data;
                },
            },
            { name: "uniqueAssigneeVO.accountId", title: "계정 아이디", data: "uniqueAssigneeVO.accountId", visible: false, defaultContent: 'N/A' },
            { name: "uniqueAssigneeVO.serverId", title: "ALM 서버 아이디", data: "uniqueAssignee.serverId", visible: false, defaultContent: 'N/A' }
        ];
    };

    WorkerStatusTable.prototype = Object.create($.fn.Table.prototype);
    WorkerStatusTable.prototype.constructor = WorkerStatusTable;

    $.fn.WorkerStatusTable = WorkerStatusTable;

})(jQuery);